"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFiatAmountFromUiTokenAmount = exports.getTokenAmountFromUiFiatAmount = exports.unScale = exports.scale = exports.getRemaningAccounts = exports.getTokenRateOverUsd = exports.getUsdRate = exports.getTokenRateOverRenec = exports.getRenecRate = exports.DEFAULT_EXPO = exports.DENOMINATOR = void 0;
const decimal_js_1 = __importDefault(require("decimal.js"));
const common_sdk_1 = require("@orca-so/common-sdk");
const web3_js_1 = require("@solana/web3.js");
const anchor_1 = require("@project-serum/anchor");
const consts_1 = require("./consts");
__exportStar(require("./kyc-cert"), exports);
__exportStar(require("./offer"), exports);
__exportStar(require("./encrypt-decrypt"), exports);
__exportStar(require("./consts"), exports);
__exportStar(require("./convert-type"), exports);
exports.DENOMINATOR = 10000;
exports.DEFAULT_EXPO = 9;
const getRenecRate = (marketStateData) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(marketStateData.tokenMetadata.renecRate, marketStateData.tokenDecimals);
    return renecRate;
};
exports.getRenecRate = getRenecRate;
const getTokenRateOverRenec = (tokenRateInRenec) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(tokenRateInRenec).div(web3_js_1.LAMPORTS_PER_SOL).pow(-1);
    return renecRate;
};
exports.getTokenRateOverRenec = getTokenRateOverRenec;
const getUsdRate = (usdRate) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(usdRate, 9);
    return renecRate;
};
exports.getUsdRate = getUsdRate;
const getTokenRateOverUsd = (tokenRateInUsd) => {
    const renecRate = common_sdk_1.DecimalUtil.fromU64(tokenRateInUsd).div(web3_js_1.LAMPORTS_PER_SOL).pow(-1);
    return renecRate;
};
exports.getTokenRateOverUsd = getTokenRateOverUsd;
const getRemaningAccounts = (accounts) => {
    let remainingAccounts = [];
    for (let i = 0; i < accounts.length; i++) {
        remainingAccounts.push({
            isSigner: false,
            isWritable: true,
            pubkey: accounts[i],
        });
    }
    return remainingAccounts;
};
exports.getRemaningAccounts = getRemaningAccounts;
const scale = (number, expo) => {
    return common_sdk_1.DecimalUtil.toU64(new decimal_js_1.default(number), expo);
};
exports.scale = scale;
const unScale = (scaledNumber, expo) => {
    return common_sdk_1.DecimalUtil.fromU64(scaledNumber, expo).toNumber();
};
exports.unScale = unScale;
const getTokenAmountFromUiFiatAmount = (uiFiatAmount, uiRate, tokenDecimals) => {
    const fiatAmountBN = common_sdk_1.DecimalUtil.toU64(new decimal_js_1.default(uiFiatAmount), consts_1.SCALE_EXPO);
    const numerator = fiatAmountBN.mul(new anchor_1.BN(10).pow(new anchor_1.BN(tokenDecimals)));
    const rateBN = common_sdk_1.DecimalUtil.toU64(new decimal_js_1.default(uiRate), consts_1.SCALE_EXPO);
    const tokenAmountBN = numerator.div(rateBN);
    const tokenAmount = common_sdk_1.DecimalUtil.fromU64(tokenAmountBN, tokenDecimals).toNumber();
    return { uiAmount: tokenAmount, amount: tokenAmountBN };
};
exports.getTokenAmountFromUiFiatAmount = getTokenAmountFromUiFiatAmount;
const getFiatAmountFromUiTokenAmount = (uiTokenAmount, uiRate, tokenDecimals) => {
    const tokenAmountBN = common_sdk_1.DecimalUtil.toU64(new decimal_js_1.default(uiTokenAmount), tokenDecimals);
    const rateBN = common_sdk_1.DecimalUtil.toU64(new decimal_js_1.default(uiRate), consts_1.SCALE_EXPO);
    const fiatAmountBN = tokenAmountBN.mul(rateBN).div(new anchor_1.BN(10).pow(new anchor_1.BN(tokenDecimals)));
    const fiatAmount = common_sdk_1.DecimalUtil.fromU64(fiatAmountBN, consts_1.SCALE_EXPO).toNumber();
    return { uiAmount: fiatAmount, amount: fiatAmountBN };
};
exports.getFiatAmountFromUiTokenAmount = getFiatAmountFromUiTokenAmount;
